echo -off
echo "*******************************************************************"
echo "* FlashUpdate.nsh is used to flash bios rom image.                *"
echo "*                                                                 *"
echo "*                                                                 *"
echo "* [Version 0.1, 2017/11/15, 610A/MB-BIOS ]                        *"
echo "* Copyright 2017 Supermicro Inc. All Right Reserved.              *"
echo "*                                                                 *"
echo "* Note: The script is used for Idaville Only                      *"
echo "*******************************************************************"

###############
# there is one trick between built-in shell and usb's shell
# under built-in shell, it can accept the below 
# if %lasterror% == "0x5A" then
# if %lasterror% == "5A" then
# if %lasterror% == 90 then 
#
# under usb's shell, it only accept the below
# if %lasterror% == "5A" then
###############

# >>> user defined area <<<
# >>> user defined area <<<
set AFU_TOOL        AfuEfix64.efi
set MSG             none
set LOG             FlashUpdateAct.log
set TEMP_LOG        Temp.log
set SUCC_FLG_FILE   Success.flg
set FAIL_FLG_FILE   Fail.flg

# delete flag and log files
if exist %LOG% then
    rm %LOG%
endif

set MSG "There is no old source script file."
echo %MSG%
echo %MSG% >> %LOG%

#check AfuEfix64 tool
if not exist %AFU_TOOL% then
    set MSG "Error: %AFU_TOOL% file does not exist."
    echo %MSG%
    echo %MSG% >> %LOG%
    goto fail
endif

if %1 == "" then
    goto Usage
endif

# Clear Variable
set -v FLASH_STATUS NONE

goto Update_BIOS_ME


:Usage
echo "Command Usage:"
echo "1. FlashUpdateAct.nsh romfile"

set MSG "Error: Unknown arguemnt."
echo %MSG%
echo %MSG% >> %LOG%
goto fail

# >>> BEGIN:  FLASH <<<
:Update_BIOS_ME

echo "*******************************************************************"
echo "*
echo "* FDT is same. Program BIOS and ME regions...
echo "*
echo "*******************************************************************"

%AFU_TOOL% %1 /P /B /N /K /R /ME /RLC:F
goto Exit_Program_ME


:Exit_Program_ME
if not %lasterror% == 0 then
    set MSG "Error: failed to run %AFU_TOOL%."
    echo %MSG%
    echo %MSG% >> %LOG%
    goto fail 
endif
goto flashed
# >>> END: FLASH <<<

# >>> RESULT <<<<
:flashed
set -v FLASH_STATUS FLASHED
goto success

:success
echo SUCCESS > %SUCC_FLG_FILE%
goto end

:fail
echo FAIL > %FAIL_FLG_FILE%
goto end

:end